﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using MongoDB.Driver;
using MongoDB.Bson;

namespace MongoDbSchool
{
    public class Student
    {
        public ObjectId _id { set; get; }
        public string FirstName { get; set; }
        public string LastName { get; set; }
        public int Age { get; set; }
        public IEnumerable<string> Subjects { get; set; }
    }

    class Program
    {
        private static IEnumerable<Student> GetStudents()
        {
            List<Student> list = new List<Student>();
            Student entity = new Student
            {
                FirstName = "Tonći",
                LastName = "Dadić",
                Age = 23,
                Subjects = new List<string> { "Engleski", "Matematika", "Fizika", "Kemija" },
            };
            list.Add(entity);

            entity = new Student
            {
                FirstName = "Ivo",
                LastName = "Ivić",
                Age = 25,
                Subjects = new List<string> { "Francuski", "Matematika", "Fizika", "Psihologija" },
            };
            list.Add(entity);

            return list;
        }
        static void Main(string[] args)
        {
            MongoClient client = new MongoClient("mongodb://localhost:27017");
            var database = client.GetDatabase("school");
            /*
            IMongoCollection<Student> inscol = database.GetCollection<Student>("student");
            IEnumerable<Student> newStudents = GetStudents();
            inscol.InsertMany(newStudents);
            */
            IMongoCollection<BsonDocument> collection = database.GetCollection<BsonDocument>("student");
            var builder = Builders<BsonDocument>.Filter;
            var filter = builder.Eq("FirstName", "Tonći");
            var list = collection.Find(filter).ToList();

            foreach (var item in list)
            {
                Console.WriteLine("{0}", item.ToString());
            }

            // var deleteone = collection.DeleteOne(Builders<BsonDocument>.Filter.Eq("FirstName", "Tonći"));

            IMongoCollection<Student> col = database.GetCollection<Student>("student");

            List<Student> items = col.Find(x => x.FirstName == "Tonći").ToList();
            foreach(var item in items)
            {
                Console.WriteLine("{0} {1}", item.FirstName, item.LastName);
            }

            // LINQ
            col.Find(x => x.FirstName == "Tonći")
                .ForEachAsync<Student>(x => Console.WriteLine("{0} {1}", x.FirstName, x.Age));

            // delete
            //var del = col.DeleteOne<Student>(x => x.FirstName == "Ivo");

            var update = Builders<Student>.Update
                .Set(x => x.FirstName, "Ante")
                .Set(x => x.Age, 55);
            var result = col.FindOneAndUpdate<Student>(x => x.FirstName == "Ivo", update);

            Console.ReadLine();
        }
    }
}
